#include <Arduino.h>

#define RANDOM_PERCENT_ON 60
#define DELAY 100

// put function declarations here:

uint8_t pins[8] = {0};

void setup() {
  // put your setup code here, to run once:
  for(uint8_t i = 0U; i < 8U; i++){
    pins[i] = i+2;
    pinMode(pins[i], OUTPUT);
  }
  for(size_t i = 0; i < 8; i=i+2){
    digitalWrite(pins[i], LOW);
    digitalWrite(pins[i], HIGH);
  }

  

  randomSeed(analogRead(0));
  
}

void writeByte(const uint8_t (&pins)[8], const uint8_t &data){
  uint8_t bitmask = 0x01;
  for(size_t i = 0; i<8; i++){
    if(0<(data & bitmask)){
      digitalWrite(pins[i], HIGH);
    } else {
      digitalWrite(pins[i], LOW);
    }
    bitmask = bitmask << 1;
  }
}

uint8_t getRandomBit() {
  static uint8_t randomByte = random(101);
  uint8_t result = (RANDOM_PERCENT_ON > randomByte) ? 0x01 : 0x00;
  randomByte = random(101);
  return(result);
}

void loop() {
  byte bitmask = 0x01;
  byte randomd = random(256);
  while(true) {
    randomd = randomd << 1;
    randomd = randomd | getRandomBit();
    writeByte(pins, randomd);
    sleep(DELAY);
  }
}

// put function definitions here:
